<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <script src="{{ url_for('static' , filename = '/js/jquery/jquery-3.6.0.min.js')}}"></script>
    <title>jQuery - Ajax</title>
</head>
<body>
    <h1>API</h1>
    <hr>
    <p>APP_ID :
        <input id="app_id" name="app_id" type="number" />
    </p>
    <p>APP_NAME :
        <input id="app_name" name="app_name" type="text" />
    </p>
    <p>APP_VERSION :
        <input id="app_version" name="app_version" type="text" />
    </p>
    <p>APP_AUTHOR :
        <input id="app_author" name="app_author" type="text" />
    <p>APP_REMARK :
        <input id="app_remark" name="app_remark" type="text" />
    </p>
    <button id='btnAll'>All (get)</button>
    <button id="btnAdd">Add (post)</button>
    <button id="btnQuery">Query (get/:id)</button>
    <button id="btnUpdate">Update (put/:id)</button>
    <button id="btnModify">Modify (patch/:id)</button>
    <button id="btnDelete">Delete (delete/:id)</button>
    <hr>
    <h3>Result : </h3>
    <div id="console"></div>
    <hr>
    <button id="btnReset">Reset</button>
    <script>
        $(function () {
            var $edtAppId = $('#app_id');
            var $edtAppName = $('#app_name');
            var $edtAppVersion = $('#app_version');
            var $edtAppAuthor = $('#app_author');
            var $edtAppRemark = $('#app_remark');
            var $btnAll = $('#btnAll');
            var $btnAdd = $('#btnAdd');
            var $btnQuery = $('#btnQuery');
            var $btnUpdate = $('#btnUpdate');
            var $btnModify = $('#btnModify');
            var $btnDelete = $('#btnDelete');
            var $console = $('#console');
            var $btnReset = $('#btnReset');
            
            var lstData = [];

            $btnAll.off('click').on('click', function () {
                $.ajax({
                    url: '/system/app',
                    data: {},
                    type: 'GET',
                    success: function (data) {
                        lstData = data;
                        $console.text("");
                        $.each(data , function(idx ,val){
                            var btnSelect = "<button name='btnSelect' value=" +  idx + ">Select</butotn>";
                            $console.append(btnSelect);
                            $console.append("<br>")
                            $console.append("id : " + val.id + "<br>");
                            $console.append("name : " + val.name + "<br>");
                            $console.append("version : " + val.version + "<br>");
                            $console.append("author : " + val.author + "<br>");
                            $console.append("remark : " + val.remark + "<br>");
                        })
                        var $btnSelect = $('[name=btnSelect]');
                        $btnSelect.off('click').on('click',function(){
                            let idx = $(this).val();
                            $edtAppId.val(lstData[idx].id);
                            $edtAppName.val(lstData[idx].name);
                            $edtAppVersion.val(lstData[idx].version);
                            $edtAppAuthor.val(lstData[idx].author);
                            $edtAppRemark.val(lstData[idx].remark);
                        });
                    },
                    error: function (xhr) {
                        alert('Ajax request 發生錯誤');
                    }
                });
            })
            $btnAdd.off('click').on('click',function(){
                $.ajax({
                    url: '/system/app',
                    data: {
                        "app_id" : $edtAppId.val() , 
                        "app_name" : $edtAppName.val(),
                        "app_version" : $edtAppVersion.val(),
                        "app_author" : $edtAppAuthor.val(),
                        "app_remark" : $edtAppRemark.val(),
                    },
                    type: 'POST',
                    success: function (data) {
                        $console.text("result = ");
                        $console.append(data.result);
                    },
                    error: function (xhr) {
                        alert('Ajax request 發生錯誤');
                    }
                });
            });

            $btnQuery.off('click').on('click', function () {
                $.ajax({
                    url: '/system/app/' + $edtAppId.val() ,
                    data: {},
                    type: 'GET',
                    success: function (data) {
                        $console.text("");
                        $console.append("id : " + data.id + "<br>");
                        $console.append("name : " + data.name + "<br>");
                        $console.append("version : " + data.version + "<br>");
                        $console.append("author : " + data.author + "<br>");
                        $console.append("remark : " + data.remark + "<br>");

                        $edtAppId.val(lstData[idx].id);
                        $edtAppName.val(lstData[idx].name);
                        $edtAppVersion.val(lstData[idx].version);
                        $edtAppAuthor.val(lstData[idx].author);
                        $edtAppRemark.val(lstData[idx].remark);
                    },
                    error: function (xhr) {
                        alert('Ajax request 發生錯誤');
                    }
                });
            })

            $btnUpdate.off('click').on('click',function(){
                $.ajax({
                    url: '/system/app/' + $edtAppId.val() ,
                    data: {
                        "app_id" : $edtAppId.val() , 
                        "app_name" : $edtAppName.val(),
                        "app_version" : $edtAppVersion.val(),
                        "app_author" : $edtAppAuthor.val(),
                        "app_remark" : $edtAppRemark.val(),
                    },
                    type: 'PUT',
                    success: function (data) {
                        $console.text("result = ");
                        $console.append(data.result);
                    },
                    error: function (xhr) {
                        alert('Ajax request 發生錯誤');
                    }
                });
            });

            $btnModify.off('click').on('click',function(){
                $.ajax({
                    url: '/system/app/' + $edtAppId.val() ,
                    data: {
                        "app_version" : $edtAppVersion.val(),
                        "app_author" : $edtAppAuthor.val(),
                        "app_remark" : $edtAppRemark.val(),
                    },
                    type: 'PATCH',
                    success: function (data) {
                        $console.text("result = ");
                        $console.append(data.result);
                    },
                    error: function (xhr) {
                        alert('Ajax request 發生錯誤');
                    }
                });
            });

            $btnDelete.off('click').on('click',function(){
                $.ajax({
                    url: '/system/app/' + $edtAppId.val() ,
                    data: {},
                    type: 'DELETE',
                    success: function (data) {
                        $console.text("result = ");
                        $console.append(data.result);

                        $edtAppId.val("");
                        $edtAppName.val("");
                        $edtAppVersion.val("");
                        $edtAppAuthor.val("");
                        $edtAppRemark.val("");
                    },
                    error: function (xhr) {
                        alert('Ajax request 發生錯誤');
                    }
                });
            });

            $btnReset.off('click').on('click',function(){
                $.ajax({
                    url: '/system/reset',
                    data: {},
                    type: 'POST',
                    success: function (data) {
                        $console.text("result = ");
                        $console.append(data.result);
                    },
                    error: function (xhr) {
                        alert('Ajax request 發生錯誤');
                    }
                });
            });
        });
    </script>
</body>
</html>
